;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:         Jack Dunning <ceeditor@computoredge.com>
;
; Script Function: Calorie Counting App
; This is version 6 10/16/14
; RegEx was changed in TotalCalc to simpler solution
; This is Version 5 8/7/14
; Bug in calculation fixed, ListView scrolls to bottom with new item
; Update button to save and reload added on all tabs
; Previous Version 4 7/31/14
; Tabs added to support a food dictionary made from the history
; Uses two ListViews - one for each tab 

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

OnExit, UpdateFile
Global WinPos, WeightList

SelectedRow := 0

Gui +AlwaysOnTop +Resize
Gui, Add, Tab2, w600 h450 gTabClick vTabNum altsubmit, Daily Calories | Food List
Gui, Add, DateTime, xp+10 yp+30 vFood1 gChangeDate  section, LongDate 
Gui, Add, Text, ys  yp+3 xp+350, Weigh-in (lbs)
Gui, Add, Edit, ys vWeight gWeightUpdate w50 right
Gui, Add, ListView, xs y+18 section sort r10 w200 vMyListView gMyListview,  | Food  
     | Serving Size | Cal/Serv | # Servings | # Calories | Total Calories
Gui, Add, Button, section gFoodSearch , Food Search
Gui, Add, Edit, w100 ys yp+2 vFood9, Enter Food Search
Gui, Add, GroupBox, r6 w500 xs section , Food Information
Gui, Add, Text,  xp+30 yp+25  , Food or Drink
Gui, Add, Edit, w350 xp+100 yp-3 vFood2, Food
Gui, Add, Text, xp-100 yp+28, Serving Size
Gui, Add, Edit, w300 xp+100 yp-3 vFood3, Serving size
Gui, Add, Text, xp-100 yp+28, Calories/Serving
Gui, Add, Edit, w50 xp+100 yp-3 vFood4 number gTotalCalCalc right, 
Gui, Add, Text, xp+70 yp+3 , Number Servings
Gui, Add, Edit, w50 xp+100 yp-3 vFood5 gTotalCalCalc right, 
Gui, Add, Text, xp+70 yp+3, Calories
Gui, Add, Text, w50 xp+50 yp vFood6
Gui, Add, Button, xp-400 yp+23 gAddItem, Add to List
;Gui, Add, ListBox, xp-400 vFoodListAddItem, Add to List
;Gui, Add, Button, xm gUpdate, Update/Save ;xp+450

LV_ModifyCol(1, 0)
LV_ModifyCol(2, 150)
LV_ModifyCol(3, 125)
LV_ModifyCol(4, "Integer 50 NoSort")
LV_ModifyCol(5, "Float 50 NoSort")
LV_ModifyCol(6, "Integer 50 NoSort")
LV_ModifyCol(7, "Integer 50 NoSort")

Gui, Tab, 2
Gui, Add, ListView, xs y+18 section sort r22 w200 vMyFoodView, Food  
     | Serving Size | Cal/Serv  ;gMyFoodview

LV_ModifyCol(1, 250)
LV_ModifyCol(2, 175)
LV_ModifyCol(3, "Integer 50 NoSort")

Gui, ListView, MyListView

Gui, Tab
Gui, Add, Button, xm x+275 gUpdate, Update/Save ;




IfExist, CalorieCount.txt ;Add data from CalorieCount.txt to ListView
{
 FileDelete, CalorieCount3.txt 
 Filemove, CalorieCount2.txt, CalorieCount3.txt  ;back two copied to backup three
 FileMove, CalorieCount1.txt, CalorieCount2.txt  ;back one copied to backup two
 FileCopy, CalorieCount.txt, CalorieCount1.txt  ;original copied to backup one

 FileRead, CalorieCount, CalorieCount.txt

 LoadWindow(A_Now)
 Gui, ListView, MyFoodView
 FoodList()
 Gui, ListView, MyListView

}




Menu, MyFoodMenu, Add, Copy, CopyFood
Menu, MyContextMenu, Add, Copy, CopyItem
Menu, MyContextMenu, Add, Edit, EditItem
Menu, MyContextMenu, Add, Delete, DeleteItem
Menu, Tray, Add, Import Selected, ^#!C
Menu, Tray, Add, Show Calorie Count `^`!W, ShowCalorieCount


IfExist, CalorieCount.txt
  {
     FileReadLine, WinPos, CalorieCount.txt, 1
     Gui, Show, %WinPos% , Calorie Count
  }
Else
  {
     WinGetPos,X1,Y1,W1,H1,Program Manager
     X2 := W1-800
     Gui, Show, x%x2% y50 , Calorie Count
     WinWait, Calorie Count
     WinGetPos, X, Y, Width, Height, Calorie Count
     Width -= 16
     Height -= 38
     WinPos = x%x% y%y% w%Width% h%Height%
     WeighDate := SubStr(A_NOw,1,8) . "000000"
     CalorieCount := WinPos . "`r`n" . WeighDate . "     " . "`r`n"
  }

Hotkey, ^!w, ShowCalorieCount

ShowCalorieCount:
  Gui, Show,, Calorie Count
Return

Update:

  Reload

Return

MyListView:
  If A_GuiEvent = e          ;Finished editing first field of a row
    LV_ModifyCol(1,"Sort")
Return



FoodSearch:     ;Search for food items at caloriecount.about.com
 Gui, Submit, NoHide


 Run, http://caloriecount.about.com/cc/search2.php?searchpro=%Food9%

Return

TabClick:

Gui, Submit, NoHide

If TabNum = 1
    Gui, ListView, MyListView

If TabNum = 2
  Gui, ListView, MyFoodView

Return

EditItem:          ;Move row from ListView columns into edit fields
  SelectedRow := LV_GetNext()
  StringSplit, RowData, EditText , |

  Loop, 6
    {
      GuiControl, ,Food%A_Index%, % Rowdata%A_Index%
    }
  StringReplace, RowData2, RowData2, ", ""
  StringReplace, RowData3, RowData3, ", ""

  CalorieOld := Rowdata1 . ",""" . Rowdata2 . """,""" . Rowdata3 . """," . Rowdata4 . "," . Rowdata5 . "," . Rowdata6
  GuiControl, ,Button3, Update
Return

CopyItem:          ;Move row from ListView columns into edit fields
  SelectedRow := 0
  StringSplit, RowData, EditText , |

  Loop, 6
    {
      GuiControl, ,Food%A_Index%, % Rowdata%A_Index%
    }

Return

CopyFood:          ;Move row from ListView columns into edit fields

  SelectedRow := 0
  StringSplit, RowData, FoodText , |

      GuiControl, ,Food2, % Rowdata1
      GuiControl, ,Food3, % Rowdata2
      GuiControl, ,Food4, % floor(Rowdata3)
      GuiControl, ,Food5, 1
      GuiControl, ,Food6, %Rowdata3%

   Gui, ListView, MyListView
   SendInput, ^{PgUp}
   ControlFocus , Edit6, Calorie Count
Return


ChangeDate:
  Gui, Submit, NoHide
  UpdateFile()  
  LV_Delete()
  LoadWindow(Food1)
Return


WeightUpdate:
  Gui, Submit, NoHide
  WeighDate := SubStr(Food1,1,8) . "000000"
  Position := InStr(CalorieCount,WeighDate)
  OldWeight := SubStr(CalorieCount, Position, 19)
  NewWeight := WeighDate . SubStr("    " . SubStr(Weight,1,5), -4)
  StringReplace CalorieCount, CalorieCount, %OldWeight%, %NewWeight%
Return


GuiContextMenu:  ; Launched in response to a right-click or press of the Apps key.

If A_GuiControl = MyListView
  {
  LV_GetText(ColText, A_EventInfo,1)    ;Gather column data in string EditText
  EditText := ColText
  Loop 5
    {
      LV_GetText(ColText, A_EventInfo, A_Index+1)
      EditText := EditText . "|" . ColText
    }
  Menu, MyContextMenu, Show, %A_GuiX%, %A_GuiY%
  }

If A_GuiControl = MyFoodView
  {
   LV_GetText(ColText, A_EventInfo,1)    ;Gather column data in string FoodText
   FoodText := ColText

  Loop 2
    {
      LV_GetText(ColText, A_EventInfo, A_Index+1)
      FoodText := FoodText . "|" . ColText
    }
  Menu, MyFoodMenu, Show, %A_GuiX%, %A_GuiY%
  }

Return


DeleteItem:         ;Deletes selected rows
MsgBox, 4100, Delete Food?, Delete Item? Click Yes or No? 
IfMsgBox No    ;Don't delete
  Return

  SelectedRow := LV_GetNext()
  StringSplit, RowData, EditText , |

  StringReplace, RowData2, RowData2, ", ""
  StringReplace, RowData3, RowData3, ", ""

  CalorieOld := Rowdata1 . ",""" . Rowdata2 . """,""" . Rowdata3 . """," . trim(Rowdata4) . "," . trim(Rowdata5) . "," . Rowdata6

     StringReplace, CalorieCount, CalorieCount, %CalorieOld%`r`n
     StringReplace, CalorieCount, CalorieCount, %CalorieOld%`n
     StringReplace, CalorieCount, CalorieCount, %CalorieOld%

    LV_Delete(SelectedRow)  ; Clear the row from the ListView. 

Return


AddItem:                 ;Add new or update ListView row
  Gui, Submit, NoHide
  StringReplace, Food5, Food5,`,,.,all


If SelectedRow = 0
  {
    If LV_GetCount() = 0
      LastTotalCal := 0
    Else
      LV_GetText(LastTotalCal,LV_GetCount(),7)

    Food1 := SubStr(Food1,1,8) . SubStr(A_Now,9,6)
    Food6 := Round(Food4*Food5)
    Food7 := Round((Food4*Food5)+LastTotalCal)

    LV_Add("", Food1,Trim(Food2),Trim(Food3),Trim(Food4)
           ,Trim(Food5),Round(Food6),Round(Food7))
    
    NextRow += 1
    If NextRow > 10
       LV_Modify(NextRow, "Vis")


    StringReplace, Food2, Food2,", "", All
    StringReplace, Food3, Food3,", "", All


    CalorieCount := CalorieCount . Food1 . ",""" . Food2 . """,""" . Food3 . """," . Trim(Food4) . "," . Trim(Food5) . "," . Food6 . "`r`n"
  }
Else
  {
    If SelectedRow = 1
      LastTotalCal := 0
    Else
      LV_GetText(LastTotalCal,SelectedRow-1,7)

    Food6 := Round(Food4*Food5)
    Food7 := Round((Food4*Food5)+LastTotalCal)

    LV_Modify(SelectedRow,"", Food1,Food2,Food3,Food4
             ,Food5,Food6,Food7) 

    StringReplace, Food2, Food2,", "", All
    StringReplace, Food3, Food3,", "", All

    CalorieChange := Food1 . ",""" . Food2 . """,""" . Food3 . """," . Trim(Food4) . "," . Trim(Food5) . "," . Food6
    
    StringReplace, CalorieCount, CalorieCount, %CalorieOld%, %CalorieChange%


    LV_GetText(LastTotalCal, SelectedRow , 7)

    Loopnum := Lv_GetCount()-SelectedRow
    Loop, %Loopnum%
       {
          LV_GetText(Food6, SelectedRow+A_index , 6)
          Food7 := Round(Food6)+Round(LastTotalCal)
 
          LV_Modify(SelectedRow+A_index,"Col7", Food7 )
          LV_GetText(LastTotalCal, SelectedRow+A_index , 7)
       }

    SelectedRow := 0
    GuiControl, ,Button3, Add to List
  }

Return

/*
This next subroutine (GuiSize:) changes the size of the Listviews, the Tab box, and 
the location of the Update/Save button as the windows is dragged right and left.
*/

GuiSize:  ; Widen or narrow the ListViews (and Tab) in response to the user's resizing of the window.
if A_EventInfo = 1  ; The window has been minimized. No action needed.
    return

GuiControl, Move, MyListView, % "W" . (A_GuiWidth - 40)
GuiControl, Move, MyFoodView, % "W" . (A_GuiWidth - 40)
GuiControl, Move, Update/Save, % "x" . (A_GuiWidth - 100)  ;Button4
GuiControl, Move, TabNum, % "W" . (A_GuiWidth - 20)    ;SysTabControl321

Return


TotalCalCalc:        ;Calculate total calories
  Gui, Submit, NoHide
  StringReplace, Food5, Food5,`,,.,all  ;turn commas into decimals
  NewStr := RegExMatch(Food5, "[0-9]+\.?[\d]?[1-9]?" , newvalue)  ;extract number
  If NewStr = 0
     NewValue := "0." 
  NewStr := RegExMatch(NewValue, "^0\d")   ;detect single zero at beginning
  If NewStr                  ;remove single zero
     NewValue := SubStr(NewValue, 2)
  GuiControl, ,Food5, %newvalue%   ;update value of Number Servings
  SendInput, {End}                    ;place cursor at the end of the field
  TotalCalVal := Round(Food4 * Food5)
  GuiControl, ,Food6, %TotalCalVal%
Return



^#!c::               ;Import food items from caloriecount.about.com

   WinActivate, Calories         ;added for right-click menu
   WinWaitActive, Calories
   Sleep, 200
   SendInput, ^c
   Sleep, 500
    StringReplace, clipboard, clipboard, `r, , all


Loop
  {
    StringReplace, clipboard, clipboard, `n`n, `n, All, UseErrorLevel
    If ErrorLevel = 0  ; No more replacements needed.
        break
  }
    Firstchar := substr(clipboard,1,1)

    if Firstchar = `n
            StringReplace, clipboard, clipboard, `n, 

    StringSplit, RowData, Clipboard , `n, 


   GuiControl, ,Food2, %RowData1%
   Uppercheck := substr(rowdata2,1,1)
       If Uppercheck is upper
          GuiControl, ,Food2, %RowData1%, %Rowdata2%
       Else if Uppercheck is digit
          GuiControl, ,Food2, %RowData1%, %Rowdata2%
   GuiControl, ,Food5, 1

   SelectedRow := 0
   GuiControl, ,Button3, Add to List

   Loop, %Rowdata0%
    {
       If rowdata%A_Index% contains Serving Size
            {
              StringReplace, RowData%A_Index%, RowData%A_Index%,", "", All
              StringReplace, RowData%A_Index%, RowData%A_Index%,`r,, All
              StringReplace, RowData%A_Index%, RowData%A_Index%,`n,, All
              StringReplace, Serving, RowData%A_Index%,Serving Size%A_Space%, 
              GuiControl, ,Food3, %Serving%
            }
       If rowdata%A_Index% contains Grade
            {
              Next := A_Index+1
              StringReplace, RowData%Next%, RowData%Next%, `r
              StringReplace, RowData%Next%, RowData%Next%, Calories
              GuiControl, ,Food4, % trim(RowData%Next%)
              GuiControl, ,Food6, % trim(RowData%Next%)
            }
    }


Return

UpdateFile:  ;When exiting
  DetectHiddenWindows On
  UpdateFile()
  ExitApp
Return


UpdateFile()    ;Saves data to file when ListView updated
  {
    Global
    FileDelete, CalorieCount.txt
    WinGet, Min, MinMax, Calorie Count
    If Min = -1
      WinRestore, Calorie Count
    WinGetPos, X, Y, Width, Height, Calorie Count
    Width -= 16
    Height -= 38
    NewPos = x%x% y%y% w%Width% h%Height%
    FileAppend, %NewPos%, CalorieCount.txt

    StringReplace, CalorieCount, CalorieCount, %WinPos%,
    CalorieSort := CalorieCount
    Sort, CalorieCount, u

    StringReplace, CalorieCount, CalorieCount, `r, `n, all
    StringReplace, CalorieCount, CalorieCount, `n`n, `n, all
    StringReplace, CalorieCount, CalorieCount, `n, `r`n, all


    FileAppend, %CalorieCount%, CalorieCount.txt


   }



LoadWindow(LoadDate)
{
Global

 NextRow := 0

 WeighDate := SubStr(LoadDate,1,8) . "000000"
 Position := InStr(CalorieCount,WeighDate)

 If Position = 0
    {
           CalorieCount := CalorieCount . WeighDate . "     " . "`r`n"
    }


 Loop, parse, CalorieCount, `n
  {
  If (A_index = 1 and SubStr(A_LoopField, 1, 1) = "x")
     {
       WinPos := A_LoopField

       Continue
     }
  Else
     {

         If SubStr(A_LoopField,1,8) = subStr(LoadDate,1,8)
            {
              Loop, Parse, A_LoopField , CSV
               {
                  RowData%A_Index% := A_LoopField
               }
	       If SubStr(RowData1,9,6) = 000000
                 {
                    GuiControl, ,Weight, % Trim(SubStr(RowData1,15,5))
                    Continue
                 }

               If LV_GetCount() = 0
                 LastTotalCal := 0

              LV_Add("", RowData1,RowData2,RowData3,RowData4
               ,RowData5,RowData6,Round((RowData4*RowData5)+LastTotalCal))

              LastTotalCal := (RowData4*RowData5)+LastTotalCal
              NextRow += 1

	      If NextRow > 10
                LV_Modify(NextRow, "Vis")

            }
     }
  }
}


FoodList()
{
 Global
 Loop, parse, CalorieCount, `n    ; beginning of first half creating the FoodList variable
  {
  If (A_index = 1 and SubStr(A_LoopField, 1, 1) = "x")
     {
       Continue
     }
  Else
     {
       Loop, Parse, A_LoopField , CSV
         {
            RowData%A_Index% := A_LoopField
         }
       StringReplace, RowData2, RowData2,", |, All
       StringReplace, RowData3, RowData3,", |, All


       FoodList := FoodList . """" . RowData2 . """,""" . RowData3 . """," . RowData4 . "`r`n"

     }
  }
  Sort, FoodList , U   ; end of first half which creates the variable FoodList

  LastOne := "xxxx"   ; beginning of second half which loads MyFoodView
  Loop, parse, FoodList, `n
    {
       Loop, Parse, A_LoopField , CSV
         {
           RowData%A_Index% := A_LoopField
         }
       StringReplace, RowData1, RowData1,|, ", All
       StringReplace, RowData2, RowData2,|, ", All

       If RowData1 and RowData1 <> LastOne
             	   LV_Add("", RowData1,RowData2,RowData3)

       LastOne := RowData1
   }
  }

